#ifndef __DISK_INFO_H__
#define __DISK_INFO_H__

#include <sys/types.h>

#include <glib.h>

#ifndef MAXNAMLEN
#define MAXNAMLEN       255
#endif

/*
 * Disk Kind
 */
enum {
    CD,
    DVD,
};

enum{
    IS_FILE,
    IS_DIRECTORY,
};

typedef struct _file{
    int         file_type;
    char        file_name[MAXNAMLEN+1];
    time_t      file_date;              //last mod
    off_t       file_size;
    GSList      *dir_content;
}File;

typedef File Dir;

typedef struct _disk{
    char        disk_name[MAXNAMLEN+1]; //Disk Name
    char        *disk_desc;
    int         disk_kind;
    off_t       disk_size;              //Calcul 
    time_t      disk_date;
    GSList      *disk_content;
}Disk;

typedef struct _disks{
    GSList      *disk_list;
    off_t       total_size;
}DiskList;

extern DiskList *open_disk_db (char *);

#endif
