#include <gtk/gtk.h>

#include "disk_info.h"
#include "parse_xml.h"
#include "file_handling.h"

#include "win_add.h"
#include "win_rem.h"
#include "win.h"



void menu_edit_add (GtkAction *action,gpointer data )
{
    Disk          *disk;
    GtkWidget     *window;
    GtkWidget     *dialog;
    GtkFileFilter *dirfilt;
    GtkWidget     *treeview;
    char          *filename;
    

    window = GTK_WIDGET(data);
    dialog = gtk_file_chooser_dialog_new ("Disk Chooser",
             GTK_WINDOW(window),
             GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER,
             GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
             GTK_STOCK_OPEN, GTK_RESPONSE_ACCEPT,
             NULL);

    dirfilt = gtk_file_filter_new();
    gtk_file_filter_set_name(dirfilt,"Folder");
    

    gtk_file_chooser_add_filter(GTK_FILE_CHOOSER(dialog),dirfilt);
    if (gtk_dialog_run (GTK_DIALOG (dialog)) == GTK_RESPONSE_ACCEPT)
    {
        filename = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (dialog));

        /* Do the Dirty work here */
        disk = traverse_disk(filename);
        g_free(filename);

        /* Affiche le */
        treeview = g_object_get_data (G_OBJECT(window),"treeview");
        add_disk(disk,treeview);
    }

    gtk_widget_destroy (dialog);   
}

void menu_edit_remove(GtkAction *action,gpointer data )
{
    GtkWidget     *window;
    GtkWidget     *treeview;      
    
    window   = GTK_WIDGET(data);
    treeview = g_object_get_data(G_OBJECT(window),"treeview");
    remove_rows(treeview);
}
void menu_file_quit(GtkAction *action,gpointer data )
{
    gtk_main_quit ();
}

void menu_file_open(GtkAction *action,gpointer data )
{
    GtkWidget     *dialog;
    GtkFileFilter *xmlfilt;
    GtkWidget     *window;
    GtkWidget     *treeview;

    window = GTK_WIDGET(data);

    dialog = gtk_file_chooser_dialog_new ("Open File",
             GTK_WINDOW(window),
             GTK_FILE_CHOOSER_ACTION_OPEN,
             GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
             GTK_STOCK_OPEN, GTK_RESPONSE_ACCEPT,
             NULL);

    /* 
     * Un filtre
     */
    xmlfilt = gtk_file_filter_new();
    gtk_file_filter_set_name(xmlfilt,"XML DiskChooser File");
    gtk_file_filter_add_pattern(xmlfilt,"*.xml");

    gtk_file_chooser_add_filter(GTK_FILE_CHOOSER(dialog),xmlfilt);
    if (gtk_dialog_run (GTK_DIALOG (dialog)) == GTK_RESPONSE_ACCEPT)
    {
        char      *filename;
        DiskList  *dl;

        filename = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (dialog));

        dl = get_disk_list(filename);

        treeview = g_object_get_data (G_OBJECT(window),"treeview");

        add_disk_list(dl,treeview);
        g_free(filename);
    }

    gtk_widget_destroy (dialog);
}
