#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <gtk/gtk.h>

#include "util.h"

#include "disk_info.h"

#include "win.h"
#include "win_add.h"
#include "menu_uim.h"


void add_dir(Dir *d,GtkTreeIter *iter,GtkWidget *treeview)
{
    GtkTreeModel        *model;
    GSList              *dir_cont;
    File                *file;
    char                buf[21]; //log(2^64)

    model = gtk_tree_view_get_model (GTK_TREE_VIEW(treeview));

    gtk_tree_store_set(GTK_TREE_STORE (model), iter,
                       COLUMN_NAME, d->file_name,
                       COLUMN_SIZE, pretty_size(d->file_size,buf),
		       COLUMN_KIND, "-",
                       COLUMN_DATE, pretty_date(d->file_date),
                       COLUMN_DATA, d,
		       -1);
                    
    dir_cont = d->dir_content;
    while(dir_cont){
        GtkTreeIter   iter2;

        gtk_tree_store_insert (GTK_TREE_STORE (model), &iter2,iter,0);

        file = (File*)dir_cont->data;
        if(file->file_type == IS_FILE)
            add_file(file,&iter2,treeview);
        else
            add_dir(file,&iter2,treeview);
        dir_cont = dir_cont->next;
    }                           
}

void add_file(File *f, GtkTreeIter *iter, GtkWidget *treeview)
{
    GtkTreeModel        *model;
    char                buf[22]; //log(2^64) + 1 

    model = gtk_tree_view_get_model (GTK_TREE_VIEW(treeview));

    gtk_tree_store_set    (GTK_TREE_STORE (model), iter,
                           COLUMN_NAME, f->file_name,
                           COLUMN_SIZE, pretty_size(f->file_size,buf),
		           COLUMN_KIND, "-",
                           COLUMN_DATE, pretty_date(f->file_date),
                           COLUMN_DATA, f,
		           -1);
}

void add_disk(Disk *disk,  GtkWidget *treeview)
{
    GtkTreeModel        *model;
    GSList              *disk_cont;
    File                *file;
    GtkTreeIter         iter;
    char                buf[21]; //log(2^64)
    char                kind[6];

    model =  gtk_tree_view_get_model (GTK_TREE_VIEW(treeview));    


    if(disk->disk_kind == CD)
        strcpy(kind,"CDROM");
    else
        strcpy(kind,"DVD");

    gtk_tree_store_insert (GTK_TREE_STORE (model), &iter,NULL,0);
    gtk_tree_store_set    (GTK_TREE_STORE (model), &iter,
                           COLUMN_NAME, disk->disk_name,
                           COLUMN_SIZE, pretty_size(disk->disk_size,buf),
		           COLUMN_KIND, kind,
                           COLUMN_DATE, pretty_date(disk->disk_date),
                           COLUMN_DATA, disk,
		           -1);

    disk_cont = disk->disk_content;
    while(disk_cont){
        GtkTreeIter   iter2;

        gtk_tree_store_insert (GTK_TREE_STORE (model), &iter2,&iter,0);

        file = (File*)disk_cont->data;
        if(file->file_type == IS_FILE)
            add_file(file,&iter2,treeview);
        else
            add_dir(file,&iter2,treeview);
        disk_cont = disk_cont->next;
    }
   
}

void add_disk_list(DiskList *dl, GtkWidget *treeview)
{
    
    GtkTreeModel        *model;
    GSList              *tdisks;

    model = gtk_tree_view_get_model (GTK_TREE_VIEW(treeview));

    tdisks = dl->disk_list;

    for(; tdisks ; tdisks = tdisks->next)
        add_disk((Disk*)tdisks->data,treeview);
}
